(*
  Trials derived from NEW Isabelle Cookbook
*)

theory Test_Parsers_Cookbook
  imports (**) Pure (** ) HOL.Complex ( *.. for inductive even BELOW*)
begin

text \<open> trials on parsing with C.U.'s Isabelle Cookbook
  outdated:
  https://web.cs.wpi.edu/~dd/resources_isabelle/isabelle_programming.urban.pdf
  Isabelle 2019:
  http://talisker.nms.kcl.ac.uk/cgi-bin/repos.cgi/isabelle-cookbook/raw-file/tip/progtutorial.pdf
\<close>

section \<open>Work along book\<close>
subsection \<open>Scan strings\<close>
ML \<open>
\<close> ML \<open> (*p.134 \<section>6.1*)
($$ "h") (Symbol.explode "hello")
\<close> ML \<open>
($$ "h" -- $$ "e" -- $$ "l") (Symbol.explode "hello")
\<close> ML \<open>
let
  val p = Scan.optional ($$ "h") "x"
  val input1 = Symbol.explode "hello"
  val input2 = Symbol.explode "world"
in
  (p input1, p input2)
end
\<close> ML \<open>
op ||
\<close> ML \<open>
\<close>

subsection \<open>Scan token list\<close>
ML \<open>
\<close> ML \<open> (*p.141 \<section>6.2*)
Token.explode
  (Thy_Header.get_keywords' @{context}) Position.none "hello world"
\<close> ML \<open>
Token.explode: Keyword.keywords -> Position.T -> string -> Token.T list;
Thy_Header.get_keywords': Proof.context -> Keyword.keywords;
Position.none; (* = {}: Position.T *)
\<close> ML \<open>
\<close> ML \<open> (*p.142 \<section>6.2*)
let
  val input = Token.explode (Thy_Header.get_keywords' @{context}) Position.none "hello world"
in
  filter Token.is_proper input
end
\<close> ML \<open>
fun filtered_input str =
  filter Token.is_proper (Token.explode (Thy_Header.get_keywords' @{context}) Position.none str)
\<close> ML \<open>
filtered_input: string -> Token.T list
\<close> ML \<open>
\<close> ML \<open> (*p.144 \<section>6.2*)
(Parse.enum1 "|" (Parse.$$$ "in")): string list parser
\<close> text \<open>
(Parse.enum1 "|" (Parse.$$$ "in")) (filtered_input "in | in | in")
(** )
ERROR: exception MORE () raised (line 159 of "General/scan.ML")
( **)
\<close> ML \<open>
let
  val input = filtered_input "in | in | in"
  val p = Parse.enum "|" (Parse.$$$ "in")
in
  Scan.finite Token.stopper p input
end
\<close> ML \<open>
fun parse p input = Scan.finite Token.stopper (Scan.error p) input
\<close> ML \<open>
parse: (Token.T list -> 'a * Token.T list) -> Token.T list -> 'a * Token.T list
\<close> ML \<open>
parse (Parse.enum "|" (Parse.$$$ "in")) (filtered_input "in | in | in")
(*  = (["in", "in", "in"], []): string list * Token.T list *)
\<close> ML \<open>
\<close>

subsection \<open>Scan.optional\<close>
subsubsection \<open>Cookbook Scan.optional p.146 \<section>6.7\<close>
(*/----- requires HOL.Complex --------------\
inductive      (*.. HOL.Complex required *)
  even and odd
where
  even0: "even 0"
| evenS: "odd n \<Longrightarrow> even (Suc n)"
| oddS: "even n \<Longrightarrow> odd (Suc n)"
  \----- requires HOL.Complex --------------/*)
ML \<open>
(*/----- requires HOL.Complex --------------\
@{term "even 0"}
  \----- requires HOL.Complex --------------/  BUT TESTS WORK ANYWAY..*)
\<close> ML \<open>
val spec_parser =
  Parse.vars --
    Scan.optional
      (Parse.$$$ "where" |--
        Parse.!!!
          (Parse.enum1 "|"
            (Parse_Spec.opt_thm_name ":" -- Parse.prop))) []
\<close> ML \<open>
(*relate signature to _ -- Scan.optional _: ---------------------------------------------------\*)
spec_parser: ((binding * string option * mixfix) list * (Attrib.binding * string) list) parser;
(*            \------------ 'b ---------------------/   \---------- 'd --------------/  ^^^^^^*)
spec_parser:
  Token.T list ->
(*\--- 'a ---/*)
  ((binding * string option * mixfix) list * (Attrib.binding * string) list) * Token.T list
(* \------------ 'b ---------------------/   \---------- 'd --------------/    \--- 'e ---/*)
\<close> ML \<open>
Parse.vars: ((binding * string option * mixfix) list) parser
(*           \------------------ 'b ---------------/  ^^^^^^*)
\<close> ML \<open>
op -- : ('a -> 'b * 'c) * ('c -> 'd * 'e) -> 'a -> ('b * 'd) * 'e (* <--------------------------*)
\<close> ML \<open>
val aaa =
    Scan.optional
      (Parse.$$$ "where" |--
        Parse.!!!
          (Parse.enum1 "|"
            (Parse_Spec.opt_thm_name ":" -- Parse.prop)))
:
  (Attrib.binding * string) list -> Token.T list -> (Attrib.binding * string) list * Token.T list
(*\---------- 'd --------------/    \-'a='c='e-/    \---------- 'd --------------/   \-'a='c='e-/*)
\<close> ML \<open>
aaa : (Attrib.binding * string) list -> (Attrib.binding * string) list parser
(*    \---------- 'd --------------/    \---------- 'd --------------/  ^^^^^^*)
\<close> ML \<open>
Scan.optional: ('a -> 'b * 'a) -> 'b -> 'a -> 'b * 'a;
Scan.optional: ('d parser)     -> 'd -> ('d parser);
Scan.optional:
  ((Attrib.binding * string) list parser) ->
    (Attrib.binding * string) list -> ((Attrib.binding * string) list parser);
(*  \---------- 'd --------------/ ->  \---------- 'd --------------/ ^^^^^^*)
\<close> ML \<open>
val bbb =
      (Parse.$$$ "where" |--
        Parse.!!!
          (Parse.enum1 "|"
            (Parse_Spec.opt_thm_name ":" -- Parse.prop)))
:
  Token.T list -> (Attrib.binding * string) list * Token.T list;
bbb :            ((Attrib.binding * string) list) parser
(*                \---------- 'd --------------/  ^^^^^^*)
(*relate signature to _ -- Scan.optional _: ---------------------------------------------------/*)
\<close> ML \<open>
\<close> ML \<open> (* final check of spec_parser: *)
let
  val input = filtered_input (
  "  even and odd " ^
  "where " ^
  "  even0[intro]: \"even 0\" " ^
  "| evenS[intro]: \"odd \<Longrightarrow> even (Suc n)\" " ^
  "| oddS[intro]: \"even n \<Longrightarrow> odd (Suc n)\"")
in
  parse spec_parser input
end
(* =
   (([("even", NONE, NoSyn), ("odd", NONE, NoSyn)],
     [(("even0", [[Token (("intro", ({}, {})), (Ident, "intro"), Slot)]]), "<markup>"),
      (("evenS", [[Token (("intro", ({}, {})), (Ident, "intro"), Slot)]]), "<markup>"),
      (("oddS", [[Token (("intro", ({}, {})), (Ident, "intro"), Slot)]]), "<markup>")]),
    [])*)
\<close> ML \<open>
\<close>

subsection \<open>recursive parsers\<close>
subsubsection \<open>recursive parser p.140 \<section>6.1\<close>
ML \<open>
\<close> ML \<open>
datatype tree =
    Lf of string
  | Br of tree * tree
\<close> ML \<open> (* this version loops *)
fun parse_basic s =
  $$ s >> Lf || $$ "(" |-- parse_tree s --| $$ ")"
and parse_tree s =
  parse_basic s --| $$ "," -- parse_tree s >> Br || parse_basic s
\<close> ML \<open>
parse_basic: string -> string list -> tree * string list;
parse_tree : string -> string list -> tree * string list
\<close> ML \<open>
\<close> ML \<open> (* this version works *)
fun parse_basic s xs =
  ($$ s >> Lf || $$ "(" |-- parse_tree s --| $$ ")") xs
and parse_tree s xs =
  (parse_basic s --| $$ "," -- parse_tree s >> Br || parse_basic s) xs
\<close> ML \<open>
parse_basic: string -> string list -> tree * string list;
parse_tree : string -> string list -> tree * string list
\<close> ML \<open>
let
  val input = Symbol.explode "(A,((A))),A"
in
  Scan.finite Symbol.stopper (parse_tree "A") (input)
end
(*= (Br (Br (Lf "A", Lf "A"), Lf "A"), []) *)
\<close> ML \<open>
Scan.finite Symbol.stopper (parse_tree "A") (Symbol.explode "(A,((A))),A")
 = (Br (Br (Lf "A", Lf "A"), Lf "A"), [])
\<close> ML \<open>
Scan.finite Symbol.stopper (parse_tree "B") (Symbol.explode "(B,((B))),B")
 = (Br (Br (Lf "B", Lf "B"), Lf "B"), [])
\<close> ML \<open>
Br (Lf "a",                Lf "b");
Br (Lf "a",                Br (Lf "b1", Lf "b2"));
Br (Br (Lf "a1", Lf "a2"), Br (Lf "b1", Lf "b2"));
\<close> ML \<open>
\<close> ML \<open>
Scan.finite Symbol.stopper (parse_tree "A") (Symbol.explode "A")
 = (Lf "A", [])
\<close> ML \<open>
Scan.finite Symbol.stopper (parse_tree "A") (Symbol.explode "A A")
 = (Lf "A", [" ", "A"])
\<close> ML \<open>
Scan.finite Symbol.stopper (parse_tree "A") (Symbol.explode "A B")
 = (Lf "A", [" ", "B"])
\<close> ML \<open>
Scan.finite Symbol.stopper (parse_tree "A") (Symbol.explode "AB")
 = (Lf "A", ["B"])
\<close> ML \<open>
Scan.finite Symbol.stopper (parse_tree "A") (Symbol.explode "A,")
 = (Lf "A", [","])
\<close> text \<open>
Scan.finite Symbol.stopper (parse_tree "A") (Symbol.explode "(A,")
exception FAIL NONE raised (line 161 of "General/scan.ML")
\<close> ML \<open>
\<close> ML \<open>
\<close>

subsubsection \<open>recursive parser p.140 \<section>6.1 + writeln\<close>
ML \<open>
\<close> ML \<open>
fun string_of_strs strs = fold (curry op ^) (rev strs) ""
\<close> ML \<open>
fun parse_basic s xs =
(
  writeln ("parse_basic " ^ s ^ " " ^ string_of_strs xs);
  ($$ s >> Lf || $$ "(" |-- parse_tree s --| $$ ")") xs
)
and parse_tree s xs =
(
  writeln ("parse_tree  " ^ s ^ " " ^ string_of_strs xs);
  (parse_basic s --| $$ "," -- parse_tree s >> Br || parse_basic s) xs
)
\<close> ML \<open>
Scan.finite Symbol.stopper (parse_tree "A") (Symbol.explode "(A,((A))),A")
(*
parse_tree  A (A,((A))),A 
parse_basic A (A,((A))),A 
parse_tree  A A,((A))),A 
parse_basic A A,((A))),A 

parse_tree  A ((A))),A     ..1 + from here the version with tokenize differs
parse_basic A ((A))),A 
parse_tree  A (A))),A 
parse_basic A (A))),A 
parse_tree  A A))),A 
parse_basic A A))),A 
parse_basic A A))),A 
parse_basic A (A))),A 
parse_tree  A A))),A 
parse_basic A A))),A 
parse_basic A A))),A 
parse_basic A ((A))),A      ..1
parse_tree  A (A))),A 
parse_basic A (A))),A 
parse_tree  A A))),A 
parse_basic A A))),A 
parse_basic A A))),A 
parse_basic A (A))),A 
parse_tree  A A))),A 
parse_basic A A))),A 
parse_basic A A))),A 
parse_tree  A A 
parse_basic A A 
parse_basic A A 
val it = (Br (Br (Lf "A", Lf "A"), Lf "A"), []): tree * string list*)
\<close> ML \<open>
\<close> ML \<open>
\<close> ML \<open>
\<close> ML \<open>
\<close> ML \<open>
\<close> ML \<open>
\<close> ML \<open>
\<close>

subsubsection \<open>recursive parser, same with tokenise + writeln\<close>
text \<open>
  Differences between Cookbook original on strings and below on tokes
  might help to understand principles of recursive parsing.
  See also Test_Parsers:  subsection "recursive parsing" 
\<close> ML \<open>
\<close> ML \<open> (* tools from Test_Parse_Isac.thy *)
fun tokenize str =
  filter Token.is_proper (Token.explode (Thy_Header.get_keywords' @{context}) Position.none str)
fun parse parser toks = Scan.finite Token.stopper (Scan.error parser) toks
\<close> ML \<open>
val toks = tokenize "(A,((A))),A"
\<close> ML \<open>
fun string_of_toks toks = fold (curry op ^) (map Token.unparse toks |> rev) "";
string_of_toks toks = "(A,((A))),A"
\<close> ML \<open>
\<close> ML \<open> (* recursive parser p.140 \<section>6.1 adapted to tokens: *)
fun parse_basic s xs =
(
  writeln ("parse_basic " ^ s ^ " " ^ string_of_toks xs);
  (Parse.$$$ s >> Lf || Parse.$$$ "(" |-- parse_tree s --| Parse.$$$ ")") xs
)
and parse_tree s xs =
(
  writeln ("parse_tree  " ^ s ^ " " ^ string_of_toks xs);
  (parse_basic s --| Parse.$$$ "," -- parse_tree s >> Br || parse_basic s) xs
)
\<close> ML \<open>
parse_basic : string -> Token.T list -> tree * Token.T list;
parse_tree  : string -> Token.T list -> tree * Token.T list;

parse_basic : string -> tree parser;
parse_tree  : string -> tree parser;
\<close> text \<open>
(parse_tree "A") (tokenize "(A,((A))),A");
(* compare subsubsection \<open>recursive parser p.140 \<section>6.1 + writeln\<close> ..
parse_tree  A (A,((A))),A 
parse_basic A (A,((A))),A 
parse_tree  A A,((A))),A 
parse_basic A A,((A))),A
                        parser p.140 \<section>6.1: parse_tree  A ((A))),A
                                           :
parse_basic A A,((A))),A                   .. different
parse_basic A (A,((A))),A 
parse_tree  A A,((A))),A 
parse_basic A A,((A))),A 
parse_basic A A,((A))),A 
exception FAIL (SOME fn) raised (line 152 of "General/scan.ML")*)
\<close> text \<open>
(parse_basic "A") (tokenize "A");
(*
parse_basic A A 
exception FAIL (SOME fn) raised (line 152 of "General/scan.ML")*)
\<close> text \<open>
parse (parse_basic "A") (tokenize "A")
(*
parse_basic A A 
exception FAIL (SOME fn) raised (line 152 of "General/scan.ML")*)
\<close> text \<open>
(parse_tree "A") (tokenize "(A,A)");
(*
parse_tree  A (A,A) 
parse_basic A (A,A) 
parse_tree  A A,A) 
parse_basic A A,A) 
parse_basic A A,A) 
parse_basic A (A,A) 
parse_tree  A A,A) 
parse_basic A A,A) 
parse_basic A A,A) 
exception FAIL (SOME fn) raised (line 152 of "General/scan.ML")*)
\<close> ML \<open>
\<close> ML \<open>
\<close> ML \<open>
\<close> ML \<open>
\<close>


(**)end(**)
