(*
cd /usr/local/isabisac/test
/usr/local/isabisac/bin/isabelle jedit -l Isac ./Pure/library_scala.thy &
*)

theory library_scala imports Isac begin

text \<open>test/Pure/library_scala.thy 
        translate some functions from library.ML to scala 

      3-fold implementation of insertion sort, in
      # SML: below
      # Scala: below, evaluate in jEdit > Console > Scala
      # Isabelle: ~$ISABELLE_ISAC/Knowledge/InsSort.thy by rewriting
\<close>

ML \<open>
fun foldr _ [] a = a
  | foldr f (x :: xs) a = foldr f xs (f a x);
(*val foldr = fn : ('a -> 'b -> 'a) -> 'b list -> 'a -> 'a*)

(*insert a into a _sorted_ list*)
fun ins [] a = [a]
  | ins (x :: xs) a = if x < a then x :: (ins xs a) else a :: (x :: xs);
(*val ins = fn : int list -> int -> int list*)

fun sort xs = foldr ins xs [];
(*val sort = fn : int list -> int list*)
\<close>

ML \<open>
foldr (curry op +) [1,2,3] 0;
(*val it = 6 : int*)
sort [1,3,2,555,777,111,0,7,5];
(*val it = [1, 2, 3, 5, 7] : int list*)
\<close>

ML \<open>
fun add a b = a + b : int;
(add 1);
(add 1) 2;
"----------";
map;
"----------";
map (add 100) [1,2,3,4,5,6,7];

fun mmm f [] = []
  | mmm f (e::es) = (f e) :: (mmm f es);

\<close>
(*
def map (f: Int => Int) (es: List[Int]): List[Int] =
  if (es.isEmpty) List() else (f (es.head)) :: (map (f) (es.tail))
*)


(*
the same in scala:
========================================================
def foldr(f: Int => Int => Int) (is: List[Int]) (e: Int): Int =
  if (is.isEmpty) e else foldr(f) (is.tail) (f(e) (is.head))
--------------------------------------------------------
foldr: (f: (Int) => (Int) => Int)(is:val is = List(3, 4, 5)
--------------------------------------------------------
List[Int])(e: Int)Int
def add(a: Int)(b: Int) = a + b
foldr _
foldr(add) _
foldr(add)(is) _
foldr(add)(is)(0) == 12
-------------------------------------------------------- ok -- variable type >>
def foldr[A,B](f: A => B => A) (is: List[B]) (e: A): A =
  if (is.isEmpty) e else foldr(f) (is.tail) (f(e) (is.head))
--------------------------------------------------------
foldr: [A,B](f: (A) => (B) => A)(is: List[B])(e: A)A
--------------------------------------------------------
foldr _
foldr(add) _
foldr(add)(is) _
foldr(add)(is)(0) == 12
========================================================
def ins(ls: List[Int], e: Int): List[Int] = 
if (ls.isEmpty) List(e) else 
   if (ls.head < e) ls.head :: (ins(ls.tail, e)) else e :: ls 
-------------------------------------------------------- 
ins: (ls: List[Int],e: Int)List[Int]
-------------------------------------------------------- 
val ls = List(3,4,5)
ins(ls, 1) == List(1, 3, 4, 5)
ins(ls, 4) == List(3, 4, 4, 5)
ins(ls, 7) == List(3, 4, 5, 7)
-------------------------------------------------------- ok -- curried >>
def ins(is: List[Int]) (e: Int): List[Int] = 
if (is.isEmpty) List(e) else 
   if (is.head < e) is.head :: (ins(is.tail) (e)) else e :: is
--------------------------------------------------------
ins: (is: List[Int])(e: Int)List[Int]
--------------------------------------------------------
ins(is)(1) == List(1, 3, 4, 5)
ins(is)(4) == List(3, 4, 4, 5)
ins(is)(7) == List(3, 4, 5, 7)
========================================================
def sort(is: List[Int]): (List[Int]) = foldr(ins) (is) (List())
--------------------------------------------------------
sort(List(5,1,8,4)) == List(1, 4, 5, 8)

========================================================
========================================================
maps () ()
*)

end
